"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var prop_types_1 = require("prop-types");
var lodash_isplainobject_1 = require("lodash.isplainobject");
var Consumer_1 = require("./Consumer");
var Page = /** @class */ (function (_super) {
    __extends(Page, _super);
    function Page() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Page.prototype.getSections = function (parent) {
        var _a;
        if (lodash_isplainobject_1.default(parent)) {
            // Check if the element is a Section
            if (parent.type && parent.type.displayName === 'Section') {
                return _a = {}, _a[parent.props.slot] = parent, _a;
            }
            return {};
        }
        else if (Array.isArray(parent)) {
            var sections = {};
            var c = parent.length;
            for (var i = 0; i < c; i += 1) {
                sections = Object.assign({}, sections, this.getSections(parent[i]));
            }
            return sections;
        }
        return {};
    };
    Page.prototype.getLayout = function (name, layouts, sections) {
        var layout = layouts[name];
        var children = this.props.children;
        var props = __assign({}, this.props);
        delete props.layout;
        delete props.children;
        // @ts-ignore
        props.sections = sections;
        return react_1.default.createElement(layout, props, children);
    };
    Page.prototype.render = function () {
        var _this = this;
        return (react_1.default.createElement(Consumer_1.default, null, function (_a) {
            var layouts = _a.layouts;
            var sections = _this.getSections(_this.props.children);
            var layout = _this.getLayout(_this.props.layout, layouts, sections);
            if (!layout) {
                throw new Error("No layout found named: '" + _this.props.layout + "'");
            }
            return layout;
        }));
    };
    Page.propTypes = {
        layout: prop_types_1.default.string.isRequired,
        children: prop_types_1.default.node.isRequired
    };
    return Page;
}(react_1.default.Component));
exports.default = Page;
//# sourceMappingURL=Page.js.map