"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var prop_types_1 = require("prop-types");
var Slot = /** @class */ (function (_super) {
    __extends(Slot, _super);
    function Slot() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Slot.prototype.getSection = function (sectionName) {
        return this.props.sections[sectionName] || false;
    };
    Slot.prototype.render = function () {
        var _a = this.props, className = _a.className, style = _a.style, component = _a.component, wrapper = _a.wrapper;
        var section = this.getSection(this.props.name);
        var children = section ? section.props.children : this.props.children;
        var props = { className: className, style: style };
        if (!children) {
            return false;
        }
        if (wrapper) {
            return react_1.default.cloneElement(wrapper, props, children);
        }
        if (component !== '<>' && component !== '') {
            return react_1.default.createElement(component, props, children);
        }
        return children;
    };
    Slot.propTypes = {
        sections: prop_types_1.default.object.isRequired,
        name: prop_types_1.default.string.isRequired,
        component: prop_types_1.default.any,
        wrapper: prop_types_1.default.element,
        className: prop_types_1.default.string,
        style: prop_types_1.default.object,
        children: prop_types_1.default.node
    };
    Slot.defaultProps = {
        component: 'div',
        wrapper: undefined,
        className: undefined,
        style: {},
        children: false
    };
    return Slot;
}(react_1.default.Component));
exports.default = Slot;
//# sourceMappingURL=Slot.js.map